{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  :: Bugs Free QuickReport 3.0 for Delphi and C++Builder     ::
  ::                                                         ::
  :: rPrevQR.PAS - Report Preview Form                       ::
  ::                                                         ::
  :: Copyright (c) 2000-02 Bugs Free QR Team                 ::
  ::                                                         ::
  :: web: http://bfqr.da.ru                                  ::
  ::                                                         ::
  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

{$I QRDEFS.INC}

unit rPrevQR;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ToolWin, Menus, ImgList, ActnList,
  {TSK QRExport, }QRPrntr;

type
  TrNewQRPreview = class(TForm)
    StatusBar1: TStatusBar;
    QRPreview1: TQRPreview;
    ActionList1: TActionList;
    AVFirst: TAction;
    AVPrior: TAction;
    AVNext: TAction;
    AVLast: TAction;
    AVSUp: TAction;
    AVSDown: TAction;
    AVSLeft: TAction;
    AVSRight: TAction;
    AVSHome: TAction;
    AVSEnd: TAction;
    AVSFirstLine: TAction;
    AVSLastLine: TAction;
    AVZPlus10: TAction;
    AVZMinus10: TAction;
    AVZ100: TAction;
    AVZWidth: TAction;
    AVZFit: TAction;
    AVPrinterSetUp: TAction;
    AVPrint: TAction;
    AVMMain: TAction;
    AVMItem: TAction;
    AVMLeft: TAction;
    AVMRight: TAction;
    AVSave: TAction;
    AVLoad: TAction;
    ImageList1: TImageList;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N101: TMenuItem;
    N102: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N1001: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    ControlBar1: TControlBar;
    TBPage: TToolBar;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Panel2: TPanel;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    TBView: TToolBar;
    ToolButton1: TToolButton;
    ToolButton4: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    TBPrint: TToolBar;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton13: TToolButton;
    ToolButton11: TToolButton;
    ToolButton7: TToolButton;
    ToolButton12: TToolButton;
    ToolButton10: TToolButton;
    PopupMenu3: TPopupMenu;
    ImageList2: TImageList;
    AWClose: TAction;
    AWWindowClose: TAction;
    ToolBar2: TToolBar;
    ToolButton19: TToolButton;
    ProgressBar1: TProgressBar;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    AVRepreview: TAction;
    AVPageSetup: TAction;
    ToolButton20: TToolButton;
    ToolButton21: TToolButton;
    ToolButton22: TToolButton;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    ToolBar1: TToolBar;
    rLabel1: TPanel;
    ToolButton14: TToolButton;
    TabControl1: TTabControl;
    ToolButton23: TToolButton;
    AVMShowTab: TAction;
    N18: TMenuItem;
    N19: TMenuItem;
    N20: TMenuItem;
    N21: TMenuItem;
    N22: TMenuItem;
    N23: TMenuItem;
    PageEdit: TEdit;
    UpDownPage: TUpDown;
    procedure ControlBar1BandPaint(Sender: TObject; Control: TControl;
      Canvas: TCanvas; var ARect: TRect; var Options: TBandPaintOptions);
    procedure AWCloseUpdate(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure AWCloseExecute(Sender: TObject);
    procedure AVMMainUpdate(Sender: TObject);
    procedure AVMMainExecute(Sender: TObject);
    procedure AVMItemUpdate(Sender: TObject);
    procedure AVMLeftUpdate(Sender: TObject);
    procedure AVMLeftExecute(Sender: TObject);
    procedure AVMRightExecute(Sender: TObject);
    procedure AVFirstUpdate(Sender: TObject);
    procedure AVFirstExecute(Sender: TObject);
    procedure AVPriorExecute(Sender: TObject);
    procedure AVLastUpdate(Sender: TObject);
    procedure AVLastExecute(Sender: TObject);
    procedure AVNextExecute(Sender: TObject);
    procedure AVSUpUpdate(Sender: TObject);
    procedure AVSUpExecute(Sender: TObject);
    procedure AVSDownUpdate(Sender: TObject);
    procedure AVSDownExecute(Sender: TObject);
    procedure AVSLeftUpdate(Sender: TObject);
    procedure AVSLeftExecute(Sender: TObject);
    procedure AVSRightUpdate(Sender: TObject);
    procedure AVSRightExecute(Sender: TObject);
    procedure AVSHomeExecute(Sender: TObject);
    procedure AVSEndExecute(Sender: TObject);
    procedure AVSFirstLineUpdate(Sender: TObject);
    procedure AVSFirstLineExecute(Sender: TObject);
    procedure AVSLastLineExecute(Sender: TObject);
    procedure AVZPlus10Update(Sender: TObject);
    procedure AVZPlus10Execute(Sender: TObject);
    procedure AVZMinus10Update(Sender: TObject);
    procedure AVZMinus10Execute(Sender: TObject);
    procedure AVZ100Update(Sender: TObject);
    procedure AVZ100Execute(Sender: TObject);
    procedure AVZWidthUpdate(Sender: TObject);
    procedure AVZWidthExecute(Sender: TObject);
    procedure AVZFitExecute(Sender: TObject);
    procedure AVPrinterUpdate(Sender: TObject);
    procedure AVPrinterSetUpExecute(Sender: TObject);
    procedure AVPrintExecute(Sender: TObject);
    procedure AVSaveExecute(Sender: TObject);
    procedure AVLoadExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure AWWindowCloseExecute(Sender: TObject);
    procedure AVPrinterSetUpUpdate(Sender: TObject);
    procedure QRPreview1ProgressUpdate(Sender: TObject; Progress: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StatusBar1Resize(Sender: TObject);
    procedure AVRepreviewExecute(Sender: TObject);
    procedure AVPageSetupExecute(Sender: TObject);
    procedure AVPageSetupUpdate(Sender: TObject);
    procedure ToolBar1Resize(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure AVMShowTabUpdate(Sender: TObject);
    procedure AVMShowTabExecute(Sender: TObject);
    procedure ActionList1Update(Action: TBasicAction;
      var Handled: Boolean);
    procedure QRPreview1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure QRPreview1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure QRPreview1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PageEditKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    function GetPageValue: Integer;
    procedure SetPageValue(Value: Integer);
    function GetCurrentQRPreview: TQRPreview;
    function GetCurrentQRPrinter: TQRPrinter;
    procedure SetCurrentQRPrinter(Value: TQRPrinter);
    function GetQRPrinters(const Index: Integer): TQRPrinter;
    function GetActivePrinterIndex: Integer;
    procedure SetActivePrinterIndex(Index: Integer);
    function GetPrintersCount: Integer;
    procedure UpdateZoom;
  protected
    CheckClilck: Boolean;
    IsDrag: Boolean;
    FIsModal: Boolean;
    FProgressCurrentReport: Boolean;
    MouseStartPos: TPoint;

    procedure UpdateStatus;
    procedure CreateImageList;
    procedure MenuClick(Sender: TObject);
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;

    procedure OnAddPrinter(Sender: TObject; Printer: TQRPrinter);
    procedure OnRemovePrinter(Sender: TObject; Printer: TQRPrinter);
    procedure OnSwapPrinter(Sender: TObject; OldPrinter, NewPrinter: TQRPrinter);
    function IndexOfMenu(aPrinter: TQRPrinter): Integer;
    function NewCaption(Cap: String): String;

    procedure CreateParams(var Params: TCreateParams); override;

    property PageValue: Integer read GetPageValue write SetPageValue;
  public
    { Public declarations }
//    FNilForm: ^TComponent;
    constructor Create(AOwner: TComponent); override;
//    constructor CreatePreview(AOwner: TComponent; APrinter: TQRPrinter); dynamic;
//    constructor CreatePreviewModal(AOwner: TComponent; APrinter: TQRPrinter); dynamic;
    destructor Destroy; override;
    function Add(AQRPrinter: TQRPrinter): Integer;
    function Remove(AQRPrinter: TQRPrinter): Integer;
    property PrintersCount: Integer read GetPrintersCount;
    property ActivePrinterIndex: Integer read GetActivePrinterIndex write SetActivePrinterIndex;
    property CurrentPreview: TQRPreview read GetCurrentQRPreview;
    property CurrentQRPrinter: TQRPrinter read GetCurrentQRPrinter write SetCurrentQRPrinter;
    property QRPrinters[const Index: Integer]: TQRPrinter read GetQRPrinters;
    property IsModal: Boolean read FIsModal write FIsModal;
  end;

var
  rNewQRPreview: TrNewQRPreview;

implementation
uses QR3CONST, QuickRpt;

{$R *.DFM}
{$R PREVIEW.RES}

function TrNewQRPreview.Add(AQRPrinter: TQRPrinter): Integer;
begin
  Result := QRPreview1.Add(AQRPrinter);
end;

procedure TrNewQRPreview.ControlBar1BandPaint(Sender: TObject; Control: TControl;
  Canvas: TCanvas; var ARect: TRect; var Options: TBandPaintOptions);
var
  R: TRect;
begin
  if bpoGrabber in Options then begin
    Exclude(Options, bpoGrabber);
    R := ARect;
    if TControlBar(Sender).Align in [alLeft, alRight]
    then begin
      R.Bottom := R.Top+7;
      InflateRect(R,-3,-2);
    end
    else begin
      R.Right := R.Left+11;
      InflateRect(R,-4,-3);
    end;
    IntersectClipRect(canvas.Handle, R.Left, R.Top, R.Right, R.Bottom);
    InflateRect(R,1,1);
    OffsetRect(R, 0, 0);
    DrawEdge(Canvas.Handle, R,
     EDGE_RAISED,
     BF_ADJUST+BF_RECT);
     SelectClipRgn(Canvas.Handle, 0);
  end;
end;

constructor TrNewQRPreview.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  UpDownPage.Align := alRight;
  PageEdit.Align := alClient;

  IsDrag := False;
  MouseStartPos := Point(0,0);
  Caption := SqrPreviewTitle;//' ';
  if Application.Title <> EmptyStr
  then Caption := Application.Title+' - '+Caption;
  FIsModal := False;
  FProgressCurrentReport := False;
  WindowState := wsMaximized;
  CreateImageList;
  Icon.Handle := LoadIcon(hInstance,'RQRPREVIEW');
  //RQRPREVIEW - 
  QRPreview1.OnAddPrinter := OnAddPrinter;
  QRPreview1.OnRemovePrinter := OnRemovePrinter;
  QRPreview1.OnSwapPrinter := OnSwapPrinter;
end;

function TrNewQRPreview.NewCaption(Cap: String): String;
var
  L,
  I: Integer;
  C: Char;
begin
  Result := '';
  L := Length(Cap);
  for I := 1 to L do begin
    C := Cap[I];
    if C < ' ' then C := ' ';
    if (Result = '') or (C>' ') or ((C=' ') and (Result >'') and (Result[Length(Result)] <> ' '))
    then Result := Result + C;
  end;
end;

procedure TrNewQRPreview.OnAddPrinter(Sender: TObject; Printer: TQRPrinter);
var
  M: TMenuItem;
  PT,
  S: String;
  I: Integer;

  function ShortTitle(InStr: String): String;
  begin
    Result := InStr;
    if Length(Result) > 30
    then Result := Copy(Result,1,27)+'...'
  end;

begin
//  
  if TabControl1.Tabs.Count = 1
  then TabControl1.Visible := QRPreview1.PrintersCount > 1;
  if IndexOfMenu(Printer) = -1 then begin
    PT := NewCaption(Printer.Title);
    S  := PT;
    I  := 1;
    repeat
      if I <> 0 then S := Format('%d %s',[ I, PT]);
      M := PopupMenu3.Items.Find(S);
      Inc(I);
    until M = nil;
    M := TMenuItem.Create(PopupMenu3);
    M.AutoLineReduction := maParent;
    M.Action := AVMItem;
    M.Caption := S;
    M.OnClick := MenuClick;
    M.Tag := Integer(Printer);
    PopupMenu3.Items.Add(M);
    if TabControl1.Tabs.IndexOfObject(Printer) = -1
    then
      TabControl1.Tabs.AddObject(ShortTitle(S),Printer);
{
    if CheckListBox1.Items.IndexOfObject(Printer) = -1 then begin
      CheckListBox1.Items.AddObject(S,Printer)
    end;
}
  end;

end;

procedure TrNewQRPreview.OnRemovePrinter(Sender: TObject; Printer: TQRPrinter);
var
  M: TMenuItem;
  I: Integer;
begin
// 
  if Printer <> nil
  then begin
    M := nil;
    for I := 0 to PopupMenu3.Items.Count-1 do
      if TQRPrinter(PopupMenu3.Items[I].Tag) = Printer
      then begin
        M := PopupMenu3.Items[I];
        Break;
      end;
    if M <> nil then M.Free;
    I := TabControl1.Tabs.IndexOfObject(Printer);
    if I >= 0 then TabControl1.Tabs.Delete(I);
  end;
{
  I := CheckListBox1.Items.IndexOfObject(Printer);
  if I >= 0 then CheckListBox1.Items.Delete(I);
}
  if QRPreview1.PrintersCount = 0 then Close
  else CurrentQRPrinter := QRPreview1.QRPrinters[0];
end;

procedure TrNewQRPreview.OnSwapPrinter(Sender: TObject; OldPrinter, NewPrinter: TQRPrinter);
var
  I: Integer;
begin
// 
  if OldPrinter <> nil then begin
    I := IndexOfMenu(OldPrinter);
    if (I >= 0) and (NewPrinter <> nil)
    then PopupMenu3.Items[I].Tag := integer(NewPrinter);

    I := TabControl1.Tabs.IndexOfObject(OldPrinter);
    TabControl1.Tabs.Objects[I] := NewPrinter;

  end else if NewPrinter <> nil then Add(NewPrinter);
  if PageValue <> QRPreview1.PageNumber
  then begin
//    SpinEdit1.OnChange := nil;
    PageValue    := 1;
//    SpinEdit1.OnChange := SpinEdit1Change;
    PageEdit.Invalidate;
  end;
end;

function TrNewQRPreview.IndexOfMenu(aPrinter: TQRPrinter): Integer;
var
  I: Integer;
begin
  Result := -1;
  if Assigned(aPrinter) then
    for I := 0 to PopupMenu3.Items.Count - 1 do
      if TQRPrinter(PopupMenu3.Items[I].Tag) = aPrinter
      then begin
        Result := I;
        Exit;
      end;
end;

destructor TrNewQRPreview.Destroy;
begin
  inherited Destroy;
end;

function TrNewQRPreview.GetCurrentQRPreview: TQRPreview;
begin
  Result := QRPreview1;
end;

function TrNewQRPreview.GetCurrentQRPrinter: TQRPrinter;
begin
  Result := QRPreview1.QRPrinter;
end;
(*
function TrNewQRPreview.Remove(AQRPrinter: TQRPrinter): Integer;
var
  I: Integer;
  M: TMenuItem;
begin
  Result := -1;
  if FPrinterList.Count > 0 then begin
    if AQRPrinter <> nil
    then begin
      M := nil;
      for I := 0 to PopupMenu3.Items.Count-1 do
        if TQRPrinter(PopupMenu3.Items[I].Tag) = AQRPrinter
        then begin
          M := PopupMenu3.Items[I];
          Break;
        end;
      if M <> nil then M.Free;
      Result := FPrinterList.Remove(AQRPrinter);
//      AQRPrinter.ClosePreview(Self);
    end;
{
    if Assigned(AQRPrinter) and (AQRPrinter.PreviewControl=Self)
    then begin
      AQRPrinter.ClosePreview(Self);
      if AQRPrinter = CurrentQRPrinter
      then CurrentQRPrinter := nil;
    end;
}
  end;
//  if PrintersCount = 0 then Close
  if PrintersCount <> 0 then begin
    if CurrentQRPrinter = nil then CurrentQRPrinter := QRPrinters[0]
  end
  else Close;
{
   if not (csDestroying in ComponentState) then begin
    ClearGlobalPreview(Self);
    AWWindowCloseExecute(nil);
//    SendCancelMode
  end;
}
//  if Assigned(aQRPrinter) then aQRPrinter.PreviewControl := nil;
//  if Assigned(aQRPrinter) then aQRPrinter.Free;
end;
*)

function TrNewQRPreview.Remove(AQRPrinter: TQRPrinter): Integer;
begin
  Result := QRPreview1.Remove(AQRPrinter);
{    OnRemove
  if PrintersCount <> 0 then begin
    if CurrentQRPrinter = nil then CurrentQRPrinter := QRPrinters[0]
  end
  else Close;
}
end;


procedure TrNewQRPreview.UpdateStatus;
var
  I: Integer;
begin
  PageEdit.Enabled := (CurrentPreview <> nil) and (CurrentQRPrinter <> nil);
  if (CurrentQRPrinter <> nil) then begin
//    rLabel1.Caption := CurrentQRPrinter.Title;
    rLabel1.Caption := NewCaption(CurrentQRPrinter.Title);
    rLabel1.Hint := CurrentQRPrinter.Title;
    StatusBar1.Panels[0].Text := Format('%d  %d',[CurrentPreview.PageNumber,CurrentQRPrinter.PageCount]);
    StatusBar1.Panels[1].Text := Format('%d%%',[CurrentPreview.Zoom]);
    UpDownPage.Max := CurrentQRPrinter.PageCount;
    UpDownPage.Min := 1;
    PageValue      := CurrentPreview.PageNumber;
    I := TabControl1.Tabs.IndexOfObject(CurrentQRPrinter);
    if TabControl1.TabIndex <> I
    then TabControl1.TabIndex := I;
  end
  else begin
    rLabel1.Caption    := '';
    PageValue    := 1;
    UpDownPage.Max := 1;
    UpDownPage.Min := 1;
    StatusBar1.Panels[0].Text := '';
    StatusBar1.Panels[1].Text := '';
    TabControl1.TabIndex := -1;
  end;
end;

procedure TrNewQRPreview.AWCloseUpdate(Sender: TObject);
begin
  TAction(Sender).Visible := (not FIsModal and (PrintersCount > 0)) or (FIsModal and (PrintersCount > 1));
  TAction(Sender).Enabled := TAction(Sender).Visible and (CurrentQRPrinter <> nil);
end;

procedure TrNewQRPreview.CreateImageList;
var
  B: TBitmap;
  R: TRect;
begin
  B := TBitmap.Create;
  try
    B.Width  := 10;
    B.Height := 10;
    R := Rect(-2, -2, 12, 12);
    DrawFrameControl(B.Canvas.Handle,R,DFC_CAPTION, DFCS_CAPTIONCLOSE+DFCS_FLAT);
    ImageList2.AddMasked(B, clBtnFace);
    R := Rect(-3, -3, 13, 13);
    DrawFrameControl(B.Canvas.Handle,R,DFC_SCROLL,
       {DFCS_SCROLLCOMBOBOX}DFCS_SCROLLRIGHT+DFCS_FLAT);
    ImageList2.AddMasked(B, clBtnFace);
    DrawFrameControl(B.Canvas.Handle,R,DFC_SCROLL,
       DFCS_SCROLLCOMBOBOX+DFCS_FLAT);
    ImageList2.AddMasked(B, clBtnFace);
    B.Handle := LoadBitmap(hInstance, 'TB_RQRPREVIEW');
    ImageList1.AddMasked(B,B.TransparentColor);
  finally
    B.Free;
  end;
end;

procedure TrNewQRPreview.SpinEdit1Change(Sender: TObject);
begin
  if PageEdit.Text <> EmptyStr then
    PageValue := StrToIntDef(PageEdit.Text, UpDownPage.Min);
end;

function TrNewQRPreview.GetPageValue: Integer;
begin
  Result := UpDownPage.Position;
end;

procedure TrNewQRPreview.SetPageValue(Value: Integer);
begin
  UpDownPage.Position := Value;
  if (CurrentPreview <> nil) and (CurrentPreview.PageNumber <> Value)
  then CurrentPreview.PageNumber := Value;
//  UpDownPage.Invalidate;
end;

procedure TrNewQRPreview.AWCloseExecute(Sender: TObject);
var
  I: Integer;
begin
  if CurrentQRPrinter <> nil
  then begin
    I := Remove(CurrentQRPrinter);
    if (I < 0) or (I > (PrintersCount-1)) then I := 0;
    ActivePrinterIndex := I;
  end;
end;

procedure TrNewQRPreview.SetCurrentQRPrinter(Value: TQRPrinter);
begin
  QRPreview1.QRPrinter := Value;
  QRPreview1.UpdateZoom;
  UpdateStatus;
end;

function TrNewQRPreview.GetQRPrinters(const Index: Integer): TQRPrinter;
begin
  Result := QRPreview1.QRPrinters[Index];
end;

procedure TrNewQRPreview.MenuClick(Sender: TObject);
begin
  CurrentQRPrinter := TQRPrinter(TMenuItem(Sender).Tag);
end;

procedure TrNewQRPreview.AVMMainUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := PrintersCount > 1;
end;

procedure TrNewQRPreview.AVMMainExecute(Sender: TObject);
var
  I: Integer;
begin
  I := ActivePrinterIndex+1;
  if (I >= PrintersCount) then I := 0;
  ActivePrinterIndex := I;
end;

{
function TrNewQRPreview.GetActivePrinterIndex: Integer;
begin
  Result := -1;
  if CurrentQRPrinter <> nil
  then Result := FPrinterList.IndexOf(CurrentQRPrinter);
end;

procedure TrNewQRPreview.SetActivePrinterIndex(Index: Integer);
begin
  if (PrintersCount > 0) and ((Index >= 0) and (Index < PrintersCount))
  then CurrentQRPrinter := QRPrinters[Index]
  else CurrentQRPrinter := nil;
  UpdateStatus;
end;

function TrNewQRPreview.GetPrintersCount: Integer;
begin
  Result := 0;
  if FPrinterList <> nil then Result := FPrinterList.Count;
end;
}
function TrNewQRPreview.GetActivePrinterIndex: Integer;
begin
  Result := QRPreview1.ActivePrinterIndex;
end;

procedure TrNewQRPreview.SetActivePrinterIndex(Index: Integer);
begin
  QRPreview1.ActivePrinterIndex := Index;
  UpdateStatus;
end;

function TrNewQRPreview.GetPrintersCount: Integer;
begin
  Result := QRPreview1.PrintersCount;
end;

procedure TrNewQRPreview.AVMItemUpdate(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to PopupMenu3.Items.Count-1 do
    PopupMenu3.Items[I].Checked := TQRPrinter(PopupMenu3.Items[I].Tag) = CurrentQRPrinter;
end;

procedure TrNewQRPreview.AVMLeftUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := PrintersCount > 1;
end;

procedure TrNewQRPreview.AVMLeftExecute(Sender: TObject);
begin
  if PrintersCount > 0
  then if ActivePrinterIndex > 0
    then ActivePrinterIndex := (ActivePrinterIndex-1) mod PrintersCount
    else ActivePrinterIndex := PrintersCount-1;
end;

procedure TrNewQRPreview.AVMRightExecute(Sender: TObject);
begin
  if PrintersCount > 0
  then ActivePrinterIndex := (ActivePrinterIndex+1) mod PrintersCount;
end;

procedure TrNewQRPreview.AVFirstUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentQRPrinter <> nil) and
    (CurrentQRPrinter.PageCount > 0) and
    (QRPreview1.PageNumber > 1);
  UpdateStatus;
end;

procedure TrNewQRPreview.AVFirstExecute(Sender: TObject);
var
  L, V: Integer;
begin
  L := QRPreview1.HorzScrollBar.Position;
  V := QRPreview1.VertScrollBar.Position;
  QRPreview1.PageNumber := 1;
  QRPreview1.HorzScrollBar.Position := L;
  QRPreview1.VertScrollBar.Position := V;
end;

procedure TrNewQRPreview.AVPriorExecute(Sender: TObject);
var
  L, V: Integer;
begin
  L := QRPreview1.HorzScrollBar.Position;
  V := QRPreview1.VertScrollBar.Position;
  QRPreview1.PageNumber := QRPreview1.PageNumber-1;
  QRPreview1.HorzScrollBar.Position := L;
  QRPreview1.VertScrollBar.Position := V;
end;

procedure TrNewQRPreview.AVLastUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentQRPrinter <> nil) and
    (CurrentQRPrinter.PageCount > 0) and
    (QRPreview1.PageNumber < CurrentQRPrinter.PageCount);
  UpdateStatus;
end;

procedure TrNewQRPreview.AVLastExecute(Sender: TObject);
var
  L, V: Integer;
begin
  L := QRPreview1.HorzScrollBar.Position;
  V := QRPreview1.VertScrollBar.Position;
  QRPreview1.PageNumber := CurrentQRPrinter.PageCount;
  QRPreview1.HorzScrollBar.Position := L;
  QRPreview1.VertScrollBar.Position := V;
end;

procedure TrNewQRPreview.AVNextExecute(Sender: TObject);
var
  L, V: Integer;
begin
  L := QRPreview1.HorzScrollBar.Position;
  V := QRPreview1.VertScrollBar.Position;
  QRPreview1.PageNumber := QRPreview1.PageNumber+1;
  QRPreview1.HorzScrollBar.Position := L;
  QRPreview1.VertScrollBar.Position := V;
end;

procedure TrNewQRPreview.AVSUpUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and
     (CurrentQRPrinter <> nil) and
     (CurrentPreview.PageNumber >= 1);
  UpdateStatus;
end;

procedure TrNewQRPreview.AVSUpExecute(Sender: TObject);
var
  R, I: Integer;
begin
  I := CurrentPreview.VertScrollBar.Position;
  R := CurrentPreview.HorzScrollBar.Position;
  if I > 0
  then I := I-CurrentPreview.VertScrollBar.Increment;
  CurrentPreview.VertScrollBar.Position := I;
  if (CurrentPreview.VertScrollBar.Position=0) and
     (CurrentPreview.PageNumber > 1)
  then begin
     CurrentPreview.PageNumber := CurrentPreview.PageNumber-1;
     CurrentPreview.VertScrollBar.Position := CurrentPreview.VertScrollBar.Range;
  end;
  CurrentPreview.HorzScrollBar.Position := R;
end;

procedure TrNewQRPreview.AVSDownUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and
     (CurrentQRPrinter <> nil) and
     (CurrentPreview.PageNumber <= CurrentQRPrinter.PageCount) and
     (CurrentPreview.VertScrollBar.Position < CurrentPreview.VertScrollBar.Range);
  UpdateStatus;
end;

procedure TrNewQRPreview.AVSDownExecute(Sender: TObject);
var
  R, L, I: Integer;
begin
  I := CurrentPreview.VertScrollBar.Position;
  R := CurrentPreview.HorzScrollBar.Position;
  L := I;
  if I < CurrentPreview.VertScrollBar.Range
  then I := I+CurrentPreview.VertScrollBar.Increment;
  CurrentPreview.VertScrollBar.Position := I;
  if (CurrentPreview.VertScrollBar.Position=L) and
  (CurrentPreview.PageNumber < CurrentQRPrinter.PageCount) then begin
    CurrentPreview.PageNumber := CurrentPreview.PageNumber+1;
    CurrentPreview.VertScrollBar.Position := 0;
  end;
  CurrentPreview.HorzScrollBar.Position := R;
end;

procedure TrNewQRPreview.AVSLeftUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and
     (CurrentQRPrinter <> nil) and
     (CurrentPreview.HorzScrollBar.Position > 0);
  UpdateStatus;
end;

procedure TrNewQRPreview.AVSLeftExecute(Sender: TObject);
var
  D: Integer;
begin
  D := CurrentPreview.HorzScrollBar.Position-
     CurrentPreview.HorzScrollBar.Increment;
  if D < 0 then D := 0;
  CurrentPreview.HorzScrollBar.Position := D;
end;

procedure TrNewQRPreview.AVSRightUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and
     (CurrentQRPrinter <> nil) and
     (CurrentPreview.HorzScrollBar.Position < CurrentPreview.HorzScrollBar.Range);
  UpdateStatus;
end;

procedure TrNewQRPreview.AVSRightExecute(Sender: TObject);
begin
  CurrentPreview.HorzScrollBar.Position := CurrentPreview.HorzScrollBar.Position+
     CurrentPreview.HorzScrollBar.Increment;
end;

procedure TrNewQRPreview.AVSHomeExecute(Sender: TObject);
begin
  CurrentPreview.HorzScrollBar.Position := 0;
end;

procedure TrNewQRPreview.AVSEndExecute(Sender: TObject);
begin
  CurrentPreview.HorzScrollBar.Position := CurrentPreview.HorzScrollBar.Range;
end;

procedure TrNewQRPreview.AVSFirstLineUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and
     (CurrentQRPrinter <> nil) and
     (CurrentPreview.VertScrollBar.Position > 0);
  UpdateStatus;
end;

procedure TrNewQRPreview.AVSFirstLineExecute(Sender: TObject);
begin
  CurrentPreview.VertScrollBar.Position := 0;
end;

procedure TrNewQRPreview.AVSLastLineExecute(Sender: TObject);
begin
  CurrentPreview.VertScrollBar.Position := CurrentPreview.VertScrollBar.Range;
end;

procedure TrNewQRPreview.AVZPlus10Update(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and (CurrentQRPrinter <> nil) and
    (CurrentPreview.Zoom < qrpMAXZOOM);
  UpdateStatus;
end;

procedure TrNewQRPreview.AVZPlus10Execute(Sender: TObject);
begin
  CurrentPreview.Zoom := CurrentPreview.Zoom+10;
  if CurrentPreview.Zoom > qrpMAXZOOM then CurrentPreview.Zoom := qrpMAXZOOM;
  UpdateZoom;
end;

procedure TrNewQRPreview.AVZMinus10Update(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and (CurrentQRPrinter <> nil) and
    (CurrentPreview.Zoom > qrpMINZOOM);
  UpdateStatus;
end;

procedure TrNewQRPreview.AVZMinus10Execute(Sender: TObject);
begin
  CurrentPreview.Zoom := CurrentPreview.Zoom-10;
  if CurrentPreview.Zoom < qrpMINZOOM then CurrentPreview.Zoom := qrpMINZOOM;
  UpdateZoom;
end;

procedure TrNewQRPreview.AVZ100Update(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and (CurrentQRPrinter <> nil);
//   and (CurrentPreview.Zoom <> 100);
  UpdateStatus;
end;

procedure TrNewQRPreview.UpdateZoom;
begin
  AVZ100.Checked := CurrentPreview.Zoom = 100;
  AVZWidth.Checked := False;
  AVZFit.Checked := False;
end;

procedure TrNewQRPreview.AVZ100Execute(Sender: TObject);
begin
  CurrentPreview.Zoom := 100;
  UpdateZoom;
  AVZ100.Checked := True;
end;

procedure TrNewQRPreview.AVZWidthUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and
    (CurrentQRPrinter <> nil);
  UpdateStatus;
end;

procedure TrNewQRPreview.AVZWidthExecute(Sender: TObject);
begin
  CurrentPreview.ZoomToWidth;
  UpdateZoom;
  AVZWidth.Checked := True;
end;

procedure TrNewQRPreview.AVZFitExecute(Sender: TObject);
begin
  CurrentPreview.ZoomToFit;
  UpdateZoom;
  AVZFit.Checked := True;
end;

procedure TrNewQRPreview.AVPrinterUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and
      (CurrentQRPrinter <> nil)
      and (CurrentQRPrinter.Status = mpFinished) and
      not FProgressCurrentReport
//       not ProgressBar1.Visible
end;

procedure TrNewQRPreview.AVPrinterSetUpExecute(Sender: TObject);
begin
  CurrentQRPrinter.PrintWithSetup;
end;

procedure TrNewQRPreview.AVPrintExecute(Sender: TObject);
var
  I: Integer;
begin
  if (QRPreview1.PrintersCount > 1) and
     (Application.MessageBox('  ?', PChar(Application.Title), MB_YESNO+MB_ICONQUESTION)=IDYES)
  then for I := QRPreview1.PrintersCount-1 downto 0 do begin
    TCustomQuickRep(QRPreview1.QRPrinters[I].Master).PrinterSettings.FirstPage := 0;
    TCustomQuickRep(QRPreview1.QRPrinters[I].Master).PrinterSettings.LastPage  := 0;
    QRPreview1.QRPrinters[I].Print;
  end
  else begin
    TCustomQuickRep(CurrentQRPrinter.Master).PrinterSettings.FirstPage := 0;
    TCustomQuickRep(CurrentQRPrinter.Master).PrinterSettings.LastPage  := 0;
    CurrentQRPrinter.Print;
  end;
end;

procedure TrNewQRPreview.AVSaveExecute(Sender: TObject);
var
  aExportFilter : TQRExportFilter;
begin
  if CurrentQRPrinter = nil then Exit;
  aExportFilter := nil;
  with TSaveDialog.Create(Application) do
  try
    Title := SqrSaveReport;
    Filter := QRExportFilterLibrary.SaveDialogFilterString;
    DefaultExt := cQRPDefaultExt;
    if Execute then
    begin
      if FilterIndex = 1 then
        CurrentQRPrinter.Save(Filename)
      else
      begin
        try
          aExportFilter := TQRExportFilterLibraryEntry(
            QRExportFilterLibrary.Filters[FilterIndex - 2]).ExportFilterClass.Create(Filename);
          CurrentQRPrinter.ExportToFilter(aExportFilter);
        finally
          aExportFilter.Free
        end
      end
    end;
  finally
    Free;
  end;
end;

procedure TrNewQRPreview.AVLoadExecute(Sender: TObject);
begin
  with TOpenDialog.Create(Application) do
  try
    Title := SqrLoadReport;
    Filter := SqrQRFile + ' (*.' +cQRPDefaultExt + ')|*.' + cqrpDefaultExt;
    if Execute then
      if FileExists(FileName) then
      begin
        CurrentQRPrinter.Load(Filename);
        CurrentQRPrinter.PageNumber := 1;
        CurrentPreview.PreviewImage.PageNumber := 1;
      end
      else
        ShowMessage(SqrFileNotExist);
  finally
    free;
  end;
  UpdateStatus;
end;

procedure TrNewQRPreview.FormResize(Sender: TObject);
begin
  if IsWindowVisible(Handle) and (CurrentPreview <> nil) then begin
    CurrentPreview.Invalidate;
    CurrentPreview.Update;
  end;
end;

procedure TrNewQRPreview.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TrNewQRPreview.FormShow(Sender: TObject);
begin
  if QRPreview1.QRPrinter <> nil
  then QRPreview1.Zoom := 100; //ZoomToWidth;
  QRPreview1.UpdateZoom;
  UpDownPage.Invalidate;
  UpdateStatus;
end;

procedure TrNewQRPreview.Notification(AComponent: TComponent;
  Operation: TOperation);

begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then begin
    if (AComponent is TQRPreview)
    then with TQRPreview(aComponent) do begin
      OnAddPrinter    := nil;
      OnRemovePrinter := nil;
      OnSwapPrinter   := nil;
    end;
  end;
end;

procedure TrNewQRPreview.AWWindowCloseExecute(Sender: TObject);
{
var
  I: Integer;
}
begin
  Close;
{
  for I := QRPreview1.PrintersCount-1 downto 0 do
    if QRPreview1.QRPrinters[I] <> QRPreview1.QRPrinter
    then QRPreview1.QRPrinters[I].ClosePreview(Self);
  QRPreview1.QRPrinter.ClosePreview(Self);
}
end;

procedure TrNewQRPreview.AVPrinterSetUpUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and
     (CurrentQRPrinter <> nil) and not CurrentQRPrinter.ReportLoaded
       and (CurrentQRPrinter.Status = mpFinished) and
       not FProgressCurrentReport
//       not ProgressBar1.Visible
     ;
end;

procedure TrNewQRPreview.QRPreview1ProgressUpdate(Sender: TObject;
  Progress: Integer);
var
  I: Integer;
begin
  ProgressBar1.Position := Progress;
  ProgressBar1.Visible := ProgressBar1.Position in [1..99];
  if (Sender is TQRPrinter)
  and Assigned(TQRPrinter(Sender).Master)
  and Assigned(CurrentQRPrinter)
  and Assigned(CurrentQRPrinter.Master)
  and (TQRPrinter(Sender).Master=CurrentQRPrinter.Master)
  then FProgressCurrentReport := True;
  if ProgressBar1.Position >= 100 then FProgressCurrentReport := False;
  for I := 0 to ActionList1.ActionCount-1 do
    if Assigned(ActionList1.Actions[I].OnUpdate)
    then ActionList1.Actions[I].OnUpdate(ActionList1.Actions[I]);
end;

procedure TrNewQRPreview.FormDestroy(Sender: TObject);
begin
  ClearGlobalPreview(Self);
end;

procedure TrNewQRPreview.FormCreate(Sender: TObject);
begin
  CurrentPreview.Zoom := 100;
  CurrentPreview.UpdateZoom;
end;

procedure TrNewQRPreview.StatusBar1Resize(Sender: TObject);
var
  I, J: Integer;
begin
  ProgressBar1.Top := StatusBar1.Top+2;
  I := StatusBar1.Panels[1].Width+StatusBar1.Panels[0].Width+{195}225;
  J := StatusBar1.Width-(StatusBar1.Height+3+StatusBar1.Panels[0].Width);
  if I > J
  then StatusBar1.Panels[2].Width := StatusBar1.Width-(StatusBar1.Height+3+StatusBar1.Panels[0].Width+StatusBar1.Panels[1].Width)
  else StatusBar1.Panels[2].Width := 192;
  ProgressBar1.Width := StatusBar1.Panels[2].Width+48;
  ProgressBar1.Left := 3+StatusBar1.Panels[0].Width;
end;

procedure TrNewQRPreview.AVRepreviewExecute(Sender: TObject);
begin
// 
  if Assigned(QRPreview1.QRPrinter)
  then QRPreview1.QRPrinter.RePreview;
end;

procedure TrNewQRPreview.AVPageSetupExecute(Sender: TObject);
var
  Master: TComponent;
  LetsGo: Boolean;
begin
//  
  if Assigned(QRPreview1.QRPrinter) then begin
    Master := QRPreview1.QRPrinter.Master;
    LetsGo := False;
    if Assigned(Master) and
      ((Master is TCustomQuickRep) or (Master is TQRCompositeReport))
    then begin
      if (Master is TCustomQuickRep)
      then LetsGo := TCustomQuickRep(Master).PageSetup
{
      else if (Master is TQRCompositeReport)
        then LetsGo := TQRCompositeReport(Master).PageSetup;
}
      ;
    end;
    if LetsGo then
    QRPreview1.QRPrinter.RePreview;
  end;
end;

procedure TrNewQRPreview.AVPageSetupUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (CurrentPreview <> nil) and
       (CurrentQRPrinter <> nil) and not CurrentQRPrinter.ReportLoaded and
       (CurrentQRPrinter.Status = mpFinished) and
       not ProgressBar1.Visible and
       Assigned(QRPreview1.QRPrinter.Master) and
       (QRPreview1.QRPrinter.Master is TCustomQuickRep);

end;

procedure TrNewQRPreview.ToolBar1Resize(Sender: TObject);
var
  I, W: Integer;
begin
//
  W := -ToolBar1.ButtonWidth;
  for I := 0 to ToolBar1.ButtonCount-1 do
    if ToolBar1.Buttons[I].Visible then Inc(W, ToolBar1.ButtonWidth);
  rLabel1.Width := ToolBar1.Width-W-ToolBar1.BorderWidth*2-2
end;

procedure TrNewQRPreview.TabControl1Change(Sender: TObject);
var
  Prn: TQRPrinter;
begin
  Prn := TQRPrinter(TabControl1.Tabs.Objects[TabControl1.TabIndex]);
  if Prn <> CurrentQRPrinter then CurrentQRPrinter := Prn;
end;

procedure TrNewQRPreview.AVMShowTabUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := QRPreview1.PrintersCount > 1;
//  TAction(Sender).Visible := QRPreview1.PrintersCount > 1;
  TAction(Sender).ImageIndex := 1 + byte(TabControl1.Visible);
end;

procedure TrNewQRPreview.AVMShowTabExecute(Sender: TObject);
begin
  TabControl1.Visible := not TabControl1.Visible;
end;

procedure TrNewQRPreview.ActionList1Update(Action: TBasicAction;
  var Handled: Boolean);
begin
  if Action = AVMShowTab
  then begin
    TabControl1.Visible := TabControl1.Visible and (QRPreview1.PrintersCount > 1);
    N18.ImageIndex := -1;
    if TabControl1.Visible
    then TAction(Action).Caption := ' '
    else TAction(Action).Caption := ' ';
    TAction(Action).Hint := TAction(Action).Caption;
  end;
  N23.ImageIndex := -1;
end;

procedure TrNewQRPreview.QRPreview1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Shift = [ssLeft] then begin
    IsDrag := True;
    MouseStartPos := Point(X,Y);
  end;
end;

procedure TrNewQRPreview.QRPreview1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  IsDrag := False;
  MouseStartPos := Point(0,0);
end;

procedure TrNewQRPreview.QRPreview1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if IsDrag then begin
    QRPreview1.HorzScrollBar.Position := (QRPreview1.HorzScrollBar.Position+MouseStartPos.x-X) mod (QRPreview1.HorzScrollBar.Range+1);
    QRPreview1.VertScrollBar.Position := (QRPreview1.VertScrollBar.Position+MouseStartPos.y-Y) mod (QRPreview1.VertScrollBar.Range+1);
  end;
end;

procedure TrNewQRPreview.PageEditKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', Char(VK_BACK), Char(VK_DELETE)]) then begin
    Key := #0;
    MessageBeep(0);
  end;
end;

procedure TrNewQRPreview.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
end;

end.
