{==================================================================================================

  Comming Library

     .

===================================================================================================

  :

  08.07.2002 [+] SendMail:  .
  12.12.2000 [+]  .  .
  09.09.1998 [!]  Comming Library.

====================================================================================================
  Copyright 19982002 TSK Developer Laboratory, Moscow.               Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingMAPI.pas,v 1.4 2008/06/19 04:24:23 tsk Exp $
===================================================================================================}
unit CommingMAPI;

interface

  uses Forms, Dialogs, SysUtils, MAPI, CommingRegistry, Windows, CommingSystem, CommingDialog;


  function  SendMail( MsgTo, MsgSubj, MsgBody: String; ShowError: Boolean = False ): Boolean;
  function  RunMailSystem: Boolean;

  var MAPISession: Cardinal;
      MAPIMessage: TMapiMessage;
      MAPIRecip: TMapiRecipDesc;

implementation

function SendMail( MsgTo, MsgSubj, MsgBody: String; ShowError: Boolean ): Boolean;
  var Err: Integer;
begin
  Result := False;
  if ( MAPISession = 0 ) and ( not RunMailSystem ) then Exit;
  FillChar( MAPIRecip, SizeOf( MAPIRecip ), 0 );
  MAPIRecip.ulRecipClass    := MAPI_TO;
  MAPIRecip.lpszName        := PChar( MsgTo );
  MAPIMessage.nRecipCount   := 1;
  MAPIMessage.lpRecips      := @MAPIRecip;
  MAPIMessage.lpszSubject   := PChar( MsgSubj );
  MAPIMessage.lpszNoteText  := PChar( MsgBody );
  err := MapiSendMail( MAPISession, 0, MAPIMessage, 0, 0);
  Result := ( err = SUCCESS_SUCCESS );
  if not Result and ShowError
    then ShowStop( Format( ' MAPI %d   !', [ err ]));
end;
//==================================================================================================
function  RunMailSystem: Boolean;
  var err, iPos: Integer;
      MAPIexe: String;
begin
//  Result := False;
  err := MapiLogOn( Application.Handle, nil, nil, MAPI_USE_DEFAULT, 0, @MAPISession );
  Result := ( err = SUCCESS_SUCCESS );
  if Result then Exit;
  MAPIexe := RegistryGetValue( HKEY_CLASSES_ROOT, 'mailto\shell\open\command', '', '' );
  if MAPIexe = '' then exit;
  iPos := Pos( '.EXE', AnsiUpperCase( MAPIexe ));
  MAPIexe := Copy( MAPIexe, 1, iPos + 4 );
  FileExecute( MAPIexe, '', '', esHidden );
  while not Result do begin
    err := MapiLogOn( Application.Handle, nil, nil, MAPI_USE_DEFAULT, 0, @MAPISession );
    Result := ( err = SUCCESS_SUCCESS );
  end;
end;
//==================================================================================================
initialization  { Initialization section goes here }
  MAPISession := 0;
finalization    { Finalization section goes here }
  if MAPISession > 0 then MapiLogOff( MAPISession, 0, 0, 0 )
//==================================================================================================
end.
