unit CommingTreeView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls;

type
  TcoTreeView = class( TCustomTreeView )
  private     { Private declarations }
    FTSKFlat: Boolean;
    procedure   SetTSKFlat( const Value: Boolean );
  protected   { Protected declarations }
    procedure CreateParams(var Params: TCreateParams); override;
  public      { Public declarations }
  published   { Published declarations }
    property Align;
    property Anchors;
    property AutoExpand;
    property BiDiMode;
    property BorderStyle;
    property BorderWidth;
    property ChangeDelay;
    property Color;
    property Ctl3D;
    property Constraints;
    property DragKind;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property HotTrack;
    property Images;
    property Indent;
    property ParentBiDiMode;
    property ParentColor default False;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly;
    property RightClickSelect;
    property RowSelect;
    property ShowButtons;
    property ShowHint;
    property ShowLines;
    property ShowRoot;
    property SortType;
    property StateImages;
    property TabOrder;
    property TabStop default True;
    property ToolTips;
    property Visible;
    property OnAdvancedCustomDraw;
    property OnAdvancedCustomDrawItem;
    property OnChange;
    property OnChanging;
    property OnClick;
    property OnCollapsed;
    property OnCollapsing;
    property OnCompare;
    property OnContextPopup;
    property OnCustomDraw;
    property OnCustomDrawItem;
    property OnDblClick;
    property OnDeletion;
    property OnDragDrop;
    property OnDragOver;
    property OnEdited;
    property OnEditing;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnExpanding;
    property OnExpanded;
    property OnGetImageIndex;
    property OnGetSelectedIndex;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    { Items must be published after OnGetImageIndex and OnGetSelectedIndex }
    property Items;
    property    TSKFlat: Boolean read FTSKFlat write SetTSKFlat;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Comming', [ TcoTreeView ]);
end;

{ TcoTreeView }

procedure TcoTreeView.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
{  WITH Params DO begin
    ExStyle := ExStyle and not WS_EX_CLIENTEDGE ;
    WindowClass.style := WindowClass.style and CS_HREDRAW and CS_VREDRAW;
  end;}
end;

procedure TcoTreeView.SetTSKFlat( const Value: Boolean );
begin
  FTSKFlat := Value;
  if TSKFlat then begin
//    BorderStyle := bsNone;
//    BevelKind   := bkTile;
//    BevelWidth  := 2;
//    BevelInner  := bvNone;
  end;
end;

end.
